<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Crazyflie plugin for ARGoS: src/plugins/robots/crazyflie/simulator/crazyflie_battery_equipped_entity.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Crazyflie plugin for ARGoS
   </div>
   <div id="projectbrief">ADARS project -- PCOG / SnT / University of Luxembourg</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_7020b8b7abcceffa3f9f7a2d24718f16.html">plugins</a></li><li class="navelem"><a class="el" href="dir_57fbab4b29583c403f1efb5284ea3eb3.html">robots</a></li><li class="navelem"><a class="el" href="dir_82540c9fcfb987b606f5fb531cb7ce0a.html">crazyflie</a></li><li class="navelem"><a class="el" href="dir_8f67be75dbc917b3ef586b0672f32ede.html">simulator</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">crazyflie_battery_equipped_entity.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="crazyflie__battery__equipped__entity_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef CRAZY_FLIE_BATTERY_EQUIPPED_ENTITY_H</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define CRAZY_FLIE_BATTERY_EQUIPPED_ENTITY_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceargos.html">argos</a> {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;   <span class="keyword">class </span>CCrazyflieBatteryEquippedEntity;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;   <span class="keyword">class </span>CCrazyflieBatteryDischargeModel;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;}</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;argos3/core/utility/math/vector3.h&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;argos3/core/simulator/entity/entity.h&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;argos3/core/simulator/entity/embodied_entity.h&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="crazyflie__battery__equipped__entity_8h.html#a0124d2451652ec54e54d9da9eca606c9">   21</a></span>&#160;<span class="preprocessor">#define CF_BATTERY_A -2.347383e-08</span></div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="crazyflie__battery__equipped__entity_8h.html#ab5c93414bf1f2e814b417b6e0d3e37ff">   22</a></span>&#160;<span class="preprocessor">#define CF_BATTERY_B  1.582833e-05</span></div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="crazyflie__battery__equipped__entity_8h.html#ad4735a4094ceb97e2ab3fd3a585dc666">   23</a></span>&#160;<span class="preprocessor">#define CF_BATTERY_C -4.506692e-03</span></div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="crazyflie__battery__equipped__entity_8h.html#abee8221b53c093fc7055918759b499f9">   24</a></span>&#160;<span class="preprocessor">#define CF_BATTERY_D  1.009061</span></div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="crazyflie__battery__equipped__entity_8h.html#aefb7b2890765f80a116b60422649ddad">   25</a></span>&#160;<span class="preprocessor">#define CF_BATTERY_MAX_T 427.21</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceargos.html">argos</a> {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">   /****************************************/</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">   /****************************************/</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html">   35</a></span>&#160;   <span class="keyword">class </span><a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html">CCrazyflieBatteryEquippedEntity</a> : <span class="keyword">public</span> CEntity {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;   <span class="keyword">public</span>:</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a782bb563631aaa290daadf3bacdc88cd">   39</a></span>&#160;      <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a782bb563631aaa290daadf3bacdc88cd">ENABLE_VTABLE</a>();</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;   <span class="keyword">public</span>:</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;      <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#af89205fc79451f8613220a757a360678">CCrazyflieBatteryEquippedEntity</a>(CComposableEntity* pc_parent);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;      <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#af89205fc79451f8613220a757a360678">CCrazyflieBatteryEquippedEntity</a>(CComposableEntity *pc_parent,</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                                      <span class="keyword">const</span> std::string&amp; str_id,</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                                      Real f_start_charge = 1.0);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      <span class="keyword">virtual</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aac19e0eeae596efe1f85474031fc52df">~CCrazyflieBatteryEquippedEntity</a>();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#ac0389a95f52fdc0a1728d845501ab1ae">Init</a>(TConfigurationNode&amp; t_tree);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a16d03d17bd502c56e5225a0c8159349e">   53</a></span>&#160;      <span class="keyword">virtual</span> std::string <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a16d03d17bd502c56e5225a0c8159349e">GetTypeDescription</a>()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;         <span class="keywordflow">return</span> <span class="stringliteral">&quot;crazyflie_battery&quot;</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      }</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;      <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#ac8fe5461d5f6a2e3eabde9c68212004d">Update</a>();</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a38507bef1da00d37d6e14bc81bfa05a0">   59</a></span>&#160;      Real <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a38507bef1da00d37d6e14bc81bfa05a0">GetAvailableCharge</a>()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;         <span class="keywordflow">return</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aa2216f244d7068145f0dfee4b6da5efc">m_fAvailableCharge</a>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;      }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a538e635d2abdaeb4748f95c424b85a24">   63</a></span>&#160;      <span class="keywordtype">void</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a538e635d2abdaeb4748f95c424b85a24">SetAvailableCharge</a>(Real f_available_charge) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;         <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aa2216f244d7068145f0dfee4b6da5efc">m_fAvailableCharge</a> = std::min(1.0, f_available_charge);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;      }</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a08660c1c570b6fba05297ba5c04ceddf">   67</a></span>&#160;      Real <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a08660c1c570b6fba05297ba5c04ceddf">GetTimeLeft</a>()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;         <span class="keywordflow">return</span> <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#acc294cb877f79f08efd06e8e0645f17e">m_fTimeLeft</a>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;      }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;   <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#acc294cb877f79f08efd06e8e0645f17e">   75</a></span>&#160;      Real <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#acc294cb877f79f08efd06e8e0645f17e">m_fTimeLeft</a>;</div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aa2216f244d7068145f0dfee4b6da5efc">   77</a></span>&#160;      Real <a class="code" href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aa2216f244d7068145f0dfee4b6da5efc">m_fAvailableCharge</a>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;   };</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">   /****************************************/</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">   /****************************************/</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html">argos::CCrazyflieBatteryEquippedEntity</a></div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:35</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_a08660c1c570b6fba05297ba5c04ceddf"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a08660c1c570b6fba05297ba5c04ceddf">argos::CCrazyflieBatteryEquippedEntity::GetTimeLeft</a></div><div class="ttdeci">Real GetTimeLeft() const</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:67</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_a16d03d17bd502c56e5225a0c8159349e"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a16d03d17bd502c56e5225a0c8159349e">argos::CCrazyflieBatteryEquippedEntity::GetTypeDescription</a></div><div class="ttdeci">virtual std::string GetTypeDescription() const</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:53</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_a38507bef1da00d37d6e14bc81bfa05a0"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a38507bef1da00d37d6e14bc81bfa05a0">argos::CCrazyflieBatteryEquippedEntity::GetAvailableCharge</a></div><div class="ttdeci">Real GetAvailableCharge() const</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:59</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_a538e635d2abdaeb4748f95c424b85a24"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a538e635d2abdaeb4748f95c424b85a24">argos::CCrazyflieBatteryEquippedEntity::SetAvailableCharge</a></div><div class="ttdeci">void SetAvailableCharge(Real f_available_charge)</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:63</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_a782bb563631aaa290daadf3bacdc88cd"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#a782bb563631aaa290daadf3bacdc88cd">argos::CCrazyflieBatteryEquippedEntity::ENABLE_VTABLE</a></div><div class="ttdeci">ENABLE_VTABLE()</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_aa2216f244d7068145f0dfee4b6da5efc"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aa2216f244d7068145f0dfee4b6da5efc">argos::CCrazyflieBatteryEquippedEntity::m_fAvailableCharge</a></div><div class="ttdeci">Real m_fAvailableCharge</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:77</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_aac19e0eeae596efe1f85474031fc52df"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#aac19e0eeae596efe1f85474031fc52df">argos::CCrazyflieBatteryEquippedEntity::~CCrazyflieBatteryEquippedEntity</a></div><div class="ttdeci">virtual ~CCrazyflieBatteryEquippedEntity()</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.cpp:38</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_ac0389a95f52fdc0a1728d845501ab1ae"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#ac0389a95f52fdc0a1728d845501ab1ae">argos::CCrazyflieBatteryEquippedEntity::Init</a></div><div class="ttdeci">virtual void Init(TConfigurationNode &amp;t_tree)</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.cpp:44</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_ac8fe5461d5f6a2e3eabde9c68212004d"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#ac8fe5461d5f6a2e3eabde9c68212004d">argos::CCrazyflieBatteryEquippedEntity::Update</a></div><div class="ttdeci">virtual void Update()</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.cpp:59</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_acc294cb877f79f08efd06e8e0645f17e"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#acc294cb877f79f08efd06e8e0645f17e">argos::CCrazyflieBatteryEquippedEntity::m_fTimeLeft</a></div><div class="ttdeci">Real m_fTimeLeft</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.h:75</div></div>
<div class="ttc" id="aclassargos_1_1CCrazyflieBatteryEquippedEntity_html_af89205fc79451f8613220a757a360678"><div class="ttname"><a href="classargos_1_1CCrazyflieBatteryEquippedEntity.html#af89205fc79451f8613220a757a360678">argos::CCrazyflieBatteryEquippedEntity::CCrazyflieBatteryEquippedEntity</a></div><div class="ttdeci">CCrazyflieBatteryEquippedEntity(CComposableEntity *pc_parent)</div><div class="ttdef"><b>Definition:</b> crazyflie_battery_equipped_entity.cpp:18</div></div>
<div class="ttc" id="anamespaceargos_html"><div class="ttname"><a href="namespaceargos.html">argos</a></div><div class="ttdef"><b>Definition:</b> crazyflie_battery_default_sensor.cpp:16</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
